#include <iostream>
#include <string>

using namespace std;

/* suppose que le texte d'entree est bien compose uniquement de majuscules et
 * d'espaces. Aucune verification n'est faite
 * n est le decalage a appliquer a chaque lettre (modulo 26)
 */
void cesar (const string &entree, string &sortie, int n) {
  // suppose que sortie a la bonne taille et est vide, sinon il faudrait
  // commener par clear et utiliser push_back
  // suppose n >= 1
  size_t l = entree.size();
  if (n == 0) { sortie = entree; return; }
  for(size_t i = 0; i < l; i=i+1) {
    char c = entree.at(i);
    if (c == ' ') { sortie.at(i) = ' '; }
    else {
      int pos = ((c -'A') + n) % 26;
      sortie.at(i) = 'A' + pos;
    }
  }
}


/* subst designe normalement une permutation sur les lettres majuscules. */
bool subst (const string &entree, string &sortie, const string &subst) {
  bool dejaVu[26];
  size_t l = entree.size();

  if (subst.size() != 26) { return false; }

  // verifie que subst est bien a valeurs dans A..Z et injective
  for(int i = 0; i < 26; i=i+1) dejaVu[i] = false;
  for(size_t i = 0; i < 26; i=i+1) {
    char c = subst.at(i);
    if (c < 'A' or c > 'Z' or dejaVu[c - 'A']) { return false; }
    else { dejaVu[c - 'A'] = true; }
  }
  // applique la substitution a entree et stocke le resultat dans sortie
  for(size_t i = 0; i < l; i = i+1) {
    char c = entree.at(i);
    if (c < 'A' or c > 'Z') { sortie.at(i) = c; }
    else { sortie.at(i) = subst.at(c - 'A'); }
  }
  return true;
}


int main (void) {
  string input1 = "CRYPTEZ CE TEXTE", output1(input1.size(), ' ');
  string input2 = "ASSEZ", output2(input2.size(), ' ');
  string s2 = "POIUYTREZAMLKJHGFDSQNBVCXW";
  string input3 = "CSSEZ DE CRYPTER", output3(input3.size(), ' ');
  string clef = "MACLE";
  cesar(input1, output1, 3);
  cout << "Texte en clair : " << input1 << ". Texte crypte: " << output1 << endl;
  if (! subst(input2, output2, s2)) {
    cout << "Substitution incorrecte\n";
  } else {
    cout << "Texte en clair: " << input2 << ". Texte crypte: " << output2 << endl;
  }

  return 0;
}
